Require Export List.
Require Export pmov.
Require Export Bool_nat.
 
Fixpoint split_move (m : Moves) (r : Reg) {struct m} :
 option ((Moves * Reg) * Moves) :=
 match m with
   (s, d) :: tail =>
     match eq_nat_dec s r with
       left _ => Some (nil, d, tail)
      | right _ =>
          match split_move tail r with
            Some ((t1, r2, t2)) => Some ((s, d) :: t1, r2, t2)
           | None => None
          end
     end
  | nil => None
 end.
Variable def : Move.
 
Fixpoint last (M : Moves) : Move :=
 match M with   nil => def
               | m :: nil => m
               | m :: tail => last tail end.
 
Fixpoint head_but_last (M : Moves) : Moves :=
 match M with
   nil => nil
  | m' :: nil => nil
  | m' :: tail => m' :: head_but_last tail
 end.
Variable tmp : Reg.
 
Fixpoint replace_last_s (M : Moves) : Moves :=
 match M with
   nil => nil
  | m :: nil =>
      match m with   (s, d) => (tmp, d) :: nil end
  | m :: tail => m :: replace_last_s tail
 end.

Ltac CaseEq name := generalize (refl_equal name); pattern name at -1; case name.


Definition stepf (S1 : State) : State :=
   match S1 with
     (nil, nil, _) => S1
    | ((s, d) :: tl, nil, l) =>
        match eq_nat_dec s d with
          left _ => (tl, nil, l)
         | right _ => (tl, (s, d) :: nil, l)
        end
    | (t, (s, d) :: b, l) =>
        match split_move t d with
          Some ((t1, r, t2)) =>
            (t1 ++ t2, (d, r) :: ((s, d) :: b), l)
         | None =>
             match b with
               nil => (t, nil, (s, d) :: l)
              | _ =>
                  match eq_nat_dec d (fst (last b)) with
                    left _ =>
                      (t, replace_last_s b, (s, d) :: ((d, tmp) :: l))
                   | right _ => (t, b, (s, d) :: l)
                  end
             end
        end
   end.
 
 

